import { useDeepSubscription } from '@deep-foundation/deeplinks/imports/client.js';
import { useState, useEffect } from 'react';
export function useArePackagesInstalled(param) {
    const { packageNames, shouldIgnoreResultWhenLoading = false, onError } = param;
    const [packageInstallationStatuses, setPackageInstallationStatuses] = useState(undefined);
    const [mounted, setMounted] = useState(false);
    const { data, loading, error } = useDeepSubscription({
        type_id: {
            _id: ['@deep-foundation/core', 'Package'],
        },
        string: {
            value: {
                _in: packageNames
            },
        },
    });
    useEffect(() => {
        if (shouldIgnoreResultWhenLoading && loading) {
            return;
        }
        if (error) {
            onError === null || onError === void 0 ? void 0 : onError({ error });
            setPackageInstallationStatuses(undefined);
            return;
        }
        let packageInstallationStatuses = {};
        packageInstallationStatuses = packageNames.reduce((packageInstallationStatuses, packageName) => {
            packageInstallationStatuses[packageName] = !!(data && data.find(item => { var _a; return ((_a = item.value) === null || _a === void 0 ? void 0 : _a.value) === packageName; }));
            return packageInstallationStatuses;
        }, packageInstallationStatuses);
        setPackageInstallationStatuses(packageInstallationStatuses);
    }, [data, loading, error, mounted]);
    useEffect(() => {
        setMounted(true);
    }, []);
    return { packageInstallationStatuses, loading, error };
}
